<script lang="ts">
import Vue from 'vue';
import { getPageMetadata } from '~/common/meta';
import { AtcCopy } from '~/components/ai-transparency-center/index.vue';
import { Faq, SideNavigationVariant } from '~/components/common/index.vue';
import NextStep from '~/components/common/next-step.vue';
import BySolutionValueProp from '~/components/solutions/by-solution/by-solution-value-prop.vue';
import { SolutionsHero } from '~/components/solutions/index.vue';
import { AiTransparencyCenterService } from '~/services';
import { FooterEditLinkMixin } from '~/mixins';

export default Vue.extend({
  components: {
    NextStep,
    BySolutionValueProp,
    AtcCopy,
    Faq,
    SideNavigationVariant,
    SolutionsHero,
  },
  mixins: [FooterEditLinkMixin],
  async asyncData({ $aiTransparencyCenterService }: any) {
    try {
      const page = await (
        $aiTransparencyCenterService as AiTransparencyCenterService
      ).getContent();

      return { page, spaceId: page.spaceId, entryId: page.entryId };
    } catch (e) {
      throw new Error(e);
    }
  },
  head() {
    return getPageMetadata(
      this.page.metadata,
      this.$route.path,
      this.$nuxtI18nHead({ addSeoAttributes: true }),
    );
  },
});
</script>

<template>
  <section class="atc-container">
    <component
      :is="component.name"
      v-for="(component, index) in page.components"
      :key="`main-${component.name}-${index}`"
      :data="component.data"
      v-bind="component"
      :variant="component.data?.variant ? component.data?.variant : null"
    >
      <slot v-if="component.slot_enabled">
        <component
          :is="subcomponent.name"
          v-for="(subcomponent, subIndex) in component.slot_content"
          :key="`sub-${subcomponent.name}-${subIndex}`"
          v-bind="subcomponent.data"
          :data="subcomponent.data"
        />
      </slot>
    </component>
  </section>
</template>

<style scoped lang="scss">
.atc-container {
  overflow: hidden;
}

ol {
  list-style: initial;
}

ul {
  padding-top: $spacing-16;
}

section[role='main'] {
  overflow: clip;
}
</style>
